'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.mapStateToProps = mapStateToProps;
exports.fieldDispatchToProps = fieldDispatchToProps;
exports.mapDispatchToProps = mapDispatchToProps;
exports.default = connectField;

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _set = require('lodash/set');

var _set2 = _interopRequireDefault(_set);

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state, ownProps) {
  var form = {};
  (0, _forEach2.default)(ownProps.fields, function (field) {
    (0, _set2.default)(form, field.prefix, (0, _index.getState)(state, field));
  });
  return { form: form };
}
function fieldDispatchToProps(dispatch, ownProps) {
  var events = {
    fieldEvent: {},
    formEvent: {},
    formHandler: {}
  };
  (0, _forEach2.default)(ownProps.fields, function (field) {
    var _getActions = (0, _index.getActions)(field.prefix),
        fieldEvent = _getActions.fieldEvent,
        formEvent = _getActions.formEvent,
        formHandler = _getActions.formHandler;

    (0, _set2.default)(events.fieldEvent, field.prefix, (0, _redux.bindActionCreators)(fieldEvent, dispatch));
    (0, _set2.default)(events.formEvent, field.prefix, (0, _redux.bindActionCreators)(formEvent, dispatch));
    (0, _set2.default)(events.formHandler, field.prefix, (0, _redux.bindActionCreators)(formHandler, dispatch));
  });
  return events;
}
function mapDispatchToProps(dispatch, ownProps) {}

// This gets state and actions for a specific field. That is all.
// The prefix can be sent via init option or with props on each instance.
function connectField() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  // Pass in a component and it will get connected for you.
  return function (Component) {
    var mapProps = function mapProps(state, props) {
      return mapStateToProps(state, _extends({}, options, props));
    };
    var mapDispatch = function mapDispatch(dispatch, props) {
      return mapDispatchToProps(dispatch, _extends({}, options, props));
    };
    return (0, _reactRedux.connect)(mapProps, mapDispatch)(Component);
  };
}