"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPrefix = createPrefix;
exports.preventDefault = preventDefault;
exports.createPayload = createPayload;
exports.objProg = objProg;
exports.mapPartial = exports.getProgress = exports.fireProg = exports.eventProg = exports.progress = exports.progPercent = exports.PREFIX = void 0;

var _stubFalse2 = _interopRequireDefault(require("lodash/fp/stubFalse"));

var _spread2 = _interopRequireDefault(require("lodash/fp/spread"));

var _round2 = _interopRequireDefault(require("lodash/fp/round"));

var _parseInt2 = _interopRequireDefault(require("lodash/fp/parseInt"));

var _multiply2 = _interopRequireDefault(require("lodash/fp/multiply"));

var _mapValues2 = _interopRequireDefault(require("lodash/fp/mapValues"));

var _isString2 = _interopRequireDefault(require("lodash/fp/isString"));

var _isObject2 = _interopRequireDefault(require("lodash/fp/isObject"));

var _isNumber2 = _interopRequireDefault(require("lodash/fp/isNumber"));

var _isEmpty2 = _interopRequireDefault(require("lodash/fp/isEmpty"));

var _isArray2 = _interopRequireDefault(require("lodash/fp/isArray"));

var _flow2 = _interopRequireDefault(require("lodash/fp/flow"));

var _every2 = _interopRequireDefault(require("lodash/fp/every"));

var _divide2 = _interopRequireDefault(require("lodash/fp/divide"));

var _curry2 = _interopRequireDefault(require("lodash/fp/curry"));

var _at2 = _interopRequireDefault(require("lodash/fp/at"));

var _understory = require("understory");

var _capeRedux = require("cape-redux");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PREFIX = 'default';
exports.PREFIX = PREFIX;

function createPrefix(prefix) {
  if ((0, _isString2.default)(prefix)) {
    return prefix.split('.');
  }

  if ((0, _isArray2.default)(prefix) && !(0, _isEmpty2.default)(prefix)) {
    return prefix;
  }

  if ((0, _isObject2.default)(prefix) && prefix.fieldId && prefix.formId) {
    return [prefix.formId, prefix.fieldId];
  }

  return [PREFIX];
}

function preventDefault(event) {
  if (event && event.preventDefault) event.preventDefault();
}

function createPayload(payload) {
  if (!payload) return payload;
  preventDefault(payload);

  if (payload.target && payload.nativeEvent) {
    return payload.target.value || '';
  }

  return (0, _capeRedux.getPayload)(payload);
}

var progPercent = (0, _flow2.default)((0, _spread2.default)(_divide2.default), (0, _multiply2.default)(100), _round2.default);
exports.progPercent = progPercent;

var progress = function progress(progressKey, totalKey) {
  return (0, _flow2.default)((0, _at2.default)([progressKey, totalKey]), (0, _understory.overBranch)((0, _every2.default)(_isNumber2.default), progPercent, _stubFalse2.default));
}; // parseInt((progress / total) * 100, 10)


exports.progress = progress;
var eventProg = progress('loaded', 'total');
exports.eventProg = eventProg;
var fireProg = progress('bytesTransferred', 'totalBytes');
exports.fireProg = fireProg;

function objProg(status) {
  var res = eventProg(status);
  if (res === false) res = fireProg(status);
  if (res === false) throw new Error('Unable to get progress from event object.');
  return res;
}

var getProgress = (0, _understory.overBranch)(_isObject2.default, objProg, (0, _parseInt2.default)(10));
exports.getProgress = getProgress;
var mapPartial = (0, _curry2.default)(function (obj, arg) {
  return (0, _mapValues2.default)((0, _understory.callWith)(arg), obj);
});
exports.mapPartial = mapPartial;